# Changelog

## 2024-10-16 - 3.2.0 - feat(SmartDuplex)
Added method to create SmartDuplex from a WebReadableStream.

- Implemented a static method in SmartDuplex to allow creating an instance from a WebReadableStream.
- This addition enhances the capability of SmartDuplex to integrate with web streams, facilitating seamless stream manipulation across environments.

## 2024-10-14 - 3.1.2 - fix(WebDuplexStream)
Fix variable naming inconsistency in WebDuplexStream test

- Changed variable names from 'transformStream' to 'webDuplexStream' for consistency.
- Renamed 'writableStream' and 'readableStream' to 'writer' and 'reader' respectively.

## 2024-10-13 - 3.1.1 - fix(WebDuplexStream)
Improved read/write interface and error handling in WebDuplexStream

- Enhanced the IStreamToolsRead and IStreamToolsWrite interfaces for better Promise handling
- Refined readFunction and writeFunction handling to accommodate asynchronous data processing and error propagation
- Added internal _startReading method to facilitate initial data handling if readFunction is present
- Maintained backward compatibility while ensuring data continuity when no writeFunction is specified

## 2024-10-13 - 3.1.0 - feat(core)
Add support for creating Web ReadableStream from a file

- Introduced a new helper function `createWebReadableStreamFromFile` that allows for creating a Web ReadableStream from a file path.
- Updated exports in `ts/index.ts` to include `nodewebhelpers` which provides the new web stream feature.

## 2024-10-13 - 3.0.46 - fix(WebDuplexStream)
Fix errors in WebDuplexStream transformation and test logic

- Corrected async handling in WebDuplexStream write function
- Fixed `WebDuplexStream` tests to properly handle asynchronous reading and writing

## 2024-10-13 - 3.0.45 - fix(ts)
Fixed formatting issues in SmartDuplex class

- Resolved inconsistent spacing in SmartDuplex class methods and constructor.
- Ensured consistent formatting in the getWebStreams method.

## 2024-06-02 - 3.0.39 - smartduplex
Add .getWebStreams method

- Introduced a new `.getWebStreams` method in the smartduplex module, providing compatibility with the web streams API.

## 2024-03-16 - 3.0.34 - configuration
Update project configuration files

- Updated `tsconfig` for optimization.
- Modified `npmextra.json` to set the `githost` attribute.

## 2023-11-03 - 3.0.0 to 3.0.8 - core
Transition to major version 3.x

- Implemented breaking changes in the core system for better performance and feature set.
- Continuous core updates to improve stability and performance across minor version increments.
  
## 2023-11-02 - 2.0.4 to 2.0.8 - core
Core updates and a major fix

- Implemented core updates addressing minor bugs and enhancements.
- A significant breaking change update transitioning from 2.0.x to 3.0.0.
  
## 2022-03-31 - 2.0.0 - core
Major esm transition

- Implemented a breaking change by switching the core to ESM (ECMAScript Module) format for modernized module handling.
